Proxies: Just In Time Programming
 			// = replaceable placeholders 
 			// Tasks -> Tdef 
			// Synths -> NodeProxy
			
s.boot;
x = { arg freq=300; SinOsc.ar(freq) * 0.1 }.play;
x.set(\freq, 500);

	// TaskProxy with a name is a Tdef:
(
Tdef(\noodle, { 
	inf.do({ x.set(\freq, 300 + 500.rand); 0.1.wait });
}).play;
)		
			// task is stopping, but synth remains playing
Tdef(\noodle).stop;
			// task is running again
Tdef(\noodle).play;
			// replace task while playing
(
Tdef(\noodle, { 
	inf.do({ x.set(\freq, 250 + 100.rand); 0.15.wait });
}).play;
)

x.free;
x.play; // no. 

NodeProxy: a placeholder for a synthesis process.

s.boot;	// needs booted server

p = nil;
			// lives in a ProxySpace
p = p ?? { p = ProxySpace.new(s, \p).push };
//	p.pop;		
			// in a proxyspace ~name creates
			// a new neutral nodeproxy
~test;
			// select audio channels 2
~test.ar(2);		
			// plays, but is still empty
~test.play;
			// place UGen in the nodeproxy
~test = { Saw.ar(80) * 0.1 };
			// replace it while running
~test = { Pulse.ar(20, 0.1) * 0.1 };

~test.stop;
~test.fadeTime = 2; 

~test = { Pulse.ar(rrand(50, 200), 0.1) * 0.1 };

~test.play;

~test = { arg freq=40, amp = 0.3; Pulse.ar(freq, 0.1) * amp };
			// a task changing the values

			// change values while running 
~test.set(\freq, rrand(40, 200), \amp, 0.2);

~test.stop;

~test.play;

p.push;
(
Tdef(\noodle, { 
	inf.do({ 
		p[\test].set(\freq, 50 + 50.rand); 
		(0.1 * [1, 2, 3].choose).postln.wait 
	});
}).play;
)

ProxyMixer(p);

~test.play;
~test.fadeTime = 4;

~test = { arg freq=40, amp = 0.4; Impulse.ar(freq, 0.1) * amp };

~test = { arg freq=40, amp = 0.1; LFSaw.ar(freq) * amp };

~test = { arg freq=40, amp = 0.1; Pulse.ar(freq, 0.02) * amp };

~test.end(3);

// proxies can be treated like UGens! 
Spec.add( \fm, [0.5,4,\exp] );
~dust2 = { |fm=1.5| Ringz.ar(Dust.ar(10), [ 300, 400, 450]*fm, 0.2) * 0.1 }



~rev = { CombL.ar(~dust.ar, 0.1, 0.03, 1) };
~rev.play;

~rev = { CombL.ar(~dust.ar, 0.1, [0.01, 0.03, 0.02], 5) };

~dust.play;
~dust.scope;
~dust.clear;
~rev.clear;
